
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Module executionManager &#8212; pyNumericalTrials 0.1.0 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/classic.css" />
    
    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyNumericalTrials 0.1.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Module executionManager</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="toctree-wrapper compound">
</div>
<section id="module-pyNumericalTrials.executionManager">
<span id="module-executionmanager"></span><h1>Module executionManager<a class="headerlink" href="#module-pyNumericalTrials.executionManager" title="Permalink to this headline">¶</a></h1>
<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.averageSeedLabeledList">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">averageSeedLabeledList</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">argValues2DList</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">results</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">swept_arg_names</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.averageSeedLabeledList" title="Permalink to this definition">¶</a></dt>
<dd><p>Similar to stripSeedNcombine, but with a disorder average involved</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.avgKey">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">avgKey</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">listOdics</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.avgKey" title="Permalink to this definition">¶</a></dt>
<dd><p>takes a list and of dictionaries and returns of the average of values specified by a key</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.dicToCSV">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">dicToCSV</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">listOdics</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">swept_arg_names</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_result_keys</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[]</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.dicToCSV" title="Permalink to this definition">¶</a></dt>
<dd><p>takes a list of dictionaries with all the same keys and produces a 2D array, where the first index gives a key and the second gives an element in the list of dictionires:
csv[key, dicIdx]</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.dictionaryAvg">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">dictionaryAvg</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">listOdics</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.dictionaryAvg" title="Permalink to this definition">¶</a></dt>
<dd><p>averages a list who elements are dictionary, the average is done key by key</p>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">executionManager</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dataLocBase</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">compute_point</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">result_keys</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">result_keys_format</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">{}</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager" title="Permalink to this definition">¶</a></dt>
<dd><p>This class manages parellel execution for disorder averaging and sweeping a set of arguments.</p>
<dl class="simple">
<dt>The arguments to be swept are given in a seperate file specified by</dt><dd><p>args.sweepfile</p>
</dd>
</dl>
<p>That file must have the format of a set of lines with entries:</p>
<blockquote>
<div><p>‘linOlog’, ‘argName’ , ‘x0’,  ‘xf’, ‘n’
str      , str       , float, float, int</p>
</div></blockquote>
<p>With this arg, this class generates the set of parameters to sweep over</p>
<p>The function executeParalell() then uses the multiprocessing library
to make calls to the function compute_point, this function should have the form:</p>
<blockquote>
<div><p>compute_point(args, swept_arg_names)</p>
</div></blockquote>
<dl class="simple">
<dt>And it should then return:</dt><dd><p>a dictionary with keys given by result_keys</p>
</dd>
</dl>
<p>The function averageNsave will, if disorder was involved average over the disorder
and then save the file to a csv called PhaseDiagram.csv (only if there are 0D results)  or an sqlDatabase</p>
<p>In this way, a script that uses a single set of parameters acting on a single disorder realization can be turrned in the a multi-core script which averages over the disorder
and can sweep any parameter.</p>
<dl class="py attribute">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.args">
<span class="sig-name descname"><span class="pre">args</span></span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.args" title="Permalink to this definition">¶</a></dt>
<dd><p>args parsed by ArgParse</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.dirBase">
<span class="sig-name descname"><span class="pre">dirBase</span></span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.dirBase" title="Permalink to this definition">¶</a></dt>
<dd><p>location where to save data (without ending ‘/’) I’m sorry for having chosen this convension :(</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.compute_point">
<span class="sig-name descname"><span class="pre">compute_point</span></span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.compute_point" title="Permalink to this definition">¶</a></dt>
<dd><p>function with format compute_point(args, swept_arg_names)-&gt;dictionary with keys given by result_keys</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.result_keys">
<span class="sig-name descname"><span class="pre">result_keys</span></span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.result_keys" title="Permalink to this definition">¶</a></dt>
<dd><p>list giving names of results</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.result_keys_format">
<span class="sig-name descname"><span class="pre">result_keys_format</span></span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.result_keys_format" title="Permalink to this definition">¶</a></dt>
<dd><p>dictionary with result_keys as the keys, and 0,1,2 and values giving dimention of array for that result.</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">self.swept_arg_names,</span> <span class="pre">self.argValues2DListPseeds,</span> <span class="pre">self.argValues2DList</span></span></dt>
<dd><p>used for parameter sweep.</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.swept_args_format">
<span class="sig-name descname"><span class="pre">swept_args_format</span></span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.swept_args_format" title="Permalink to this definition">¶</a></dt>
<dd><p>dictionary giving data type of parameter being swept.</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.results">
<span class="sig-name descname"><span class="pre">results</span></span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.results" title="Permalink to this definition">¶</a></dt>
<dd><p>list of dictionaries with keys given by result_keys and values in format descirbed by result_keys_format</p>
</dd></dl>

<p class="rubric">Methods</p>
<table class="longtable docutils align-default">
<colgroup>
<col style="width: 10%" />
<col style="width: 90%" />
</colgroup>
<tbody>
<tr class="row-odd"><td><p><a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager.averageNSave" title="pyNumericalTrials.executionManager.executionManager.averageNSave"><code class="xref py py-obj docutils literal notranslate"><span class="pre">averageNSave</span></code></a>([sqlSave])</p></td>
<td><p>Preforms disorder aveage and saves as csv or sql.</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager.executeParallel" title="pyNumericalTrials.executionManager.executionManager.executeParallel"><code class="xref py py-obj docutils literal notranslate"><span class="pre">executeParallel</span></code></a>()</p></td>
<td><p>executes code in parallel using map_async.</p></td>
</tr>
</tbody>
</table>
<dl class="py method">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.averageNSave">
<span class="sig-name descname"><span class="pre">averageNSave</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">sqlSave</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.averageNSave" title="Permalink to this definition">¶</a></dt>
<dd><p>Preforms disorder aveage and saves as csv or sql.</p>
<p>csv only works if only 0D dimention results are saved.
sqlSave: bool whether to save in a sql file or not.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.executionManager.executeParallel">
<span class="sig-name descname"><span class="pre">executeParallel</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.executeParallel" title="Permalink to this definition">¶</a></dt>
<dd><p>executes code in parallel using map_async.</p>
</dd></dl>

</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.kernel">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">kernel</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">fixed</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">sweep_arg_values</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.kernel" title="Permalink to this definition">¶</a></dt>
<dd><p>this is the kernel for each CPU core, it takes a set of fixed parameters of the form:
–fixed = (args, sweet_arg_names, compute_point, original_sigint_handler)</p>
<blockquote>
<div><p>–currently: original_sigint_handler is ignored
–compute_point: is some function which takes args and swept_arg_names</p>
<p class="attribution">—sweep_arg_values: is different for each core, they are a list of values for th keys in swept_arg_names
both should be lists of same length with 1-1 maping of key-&gt;values</p>
</div></blockquote>
<dl class="simple">
<dt>this function returns a tuple: (seed, sweep_args, results)</dt><dd><p>–sweep_args: is a dictionary which identifies the arugments that were swept and there values corresponding to this result
–results: is a dictionary with keys given by result_keys</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.prep_argSweepCombinations">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">prep_argSweepCombinations</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">args</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.prep_argSweepCombinations" title="Permalink to this definition">¶</a></dt>
<dd><p>uses sweep file to generate keys(arg parameters to sweep) and their values
This function uses args.sweepfile to</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>generate a list of args that are sweept: [‘arg1’,’arg2’,…]: swept_arg_names</p></li>
<li><p>generate table of all the different argument combinations: [[arg1,arg2,…]]: argValues2DList</p></li>
<li><p>if disorder average involve, append a seed varible to that table: [[arg1,arg2,…,seed]]: argValues2DListPseeds</p></li>
</ol>
</div></blockquote>
<p>The function will also split the argValueTable</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.readSweepFile">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">readSweepFile</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">sweepfile</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.readSweepFile" title="Permalink to this definition">¶</a></dt>
<dd><p>sweepfile is a file of lines. Each line describes how to sweep a parameter:
linOlog, argName, x0, xf, n
i.e:
lin, example,   0, 5.32, 100
log, example2, -1, 1,    100
This function reads that file and produces a list of dictionaries for each line</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyNumericalTrials.executionManager.stripSeedNcombine">
<span class="sig-prename descclassname"><span class="pre">pyNumericalTrials.executionManager.</span></span><span class="sig-name descname"><span class="pre">stripSeedNcombine</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">results</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.stripSeedNcombine" title="Permalink to this definition">¶</a></dt>
<dd><p>takes the results object: (a list of tuples of the form: (seed, sweep_args, results))
removes the seed
and returns a diction including keys for both the results and sweep_args</p>
</dd></dl>

</section>
<section id="indices-and-tables">
<h1>Indices and tables<a class="headerlink" href="#indices-and-tables" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><a class="reference internal" href="genindex.html"><span class="std std-ref">Index</span></a></p></li>
<li><p><a class="reference internal" href="py-modindex.html"><span class="std std-ref">Module Index</span></a></p></li>
<li><p><a class="reference internal" href="search.html"><span class="std std-ref">Search Page</span></a></p></li>
</ul>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Module executionManager</a></li>
<li><a class="reference internal" href="#indices-and-tables">Indices and tables</a></li>
</ul>

  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/executionMangager.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyNumericalTrials 0.1.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Module executionManager</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2021, Shane P. Kelly.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.1.2.
    </div>
  </body>
</html>